#!perl -w

BEGIN {
    if ($] < 5.010) {
	print "1..0 # Skipped: perl-5.10 required\n";
	exit;
    }
}

use strict;
use Test::More;
plan tests => 9;

use Data::Pretty 'dump';

is(dump(v10), q{v10});
is(dump(v5.10.1), q{v5.10.1});
is(dump(5.10.1), q{v5.10.1});
is(dump(500.400.300.200.100), q{v500.400.300.200.100});

is(dump(\5.10.1), q{\v5.10.1});
is(dump(\v10), q{\v10});
is(dump(\\v10), q{\\\\v10});
is(dump([v10, v20, v30]), q{[v10, v20, v30]});
is(dump({ version => v6.0.0 }), q({ version => v6.0.0 }));
